#begin Language specific data
!define LANG_GERMAN 1031
!define LANG_ENGLISH 1033

LangString LangName ${LANG_ENGLISH} "English"
LangString LangName ${LANG_GERMAN} "Deutsch"
LangString Suppletoptions ${LANG_ENGLISH} "Supplets options"
LangString Suppletoptions ${LANG_GERMAN} "Suppletsoptionen"
LangString welcome2 ${LANG_ENGLISH} "This wizard will guide you through the installation process.\r\n\r\nSince Supplets is a plugin for Internet Explorer, all browser windows need to be closed for the installation process. You may do so manually now - otherwise the wizard will close all browser windows for you later.\r\n\r\nPlease click next to continue."
LangString welcome2 ${LANG_GERMAN} "Dieser Assistent wird Sie durch die Installation begleiten.\r\n\r\nDa Supplets ein Plugin fr Internet Explorer ist, mssen alle laufenden Browserfenster fr die Installation geschlossen werden. Sie knnen dies jetzt manuell vornehmen - ansonsten wird dieser Assistent fr Sie alle Browserfenster schliessen.\r\n\r\nBitte klicken Sie auf Weiter, um fortzufahren."
LangString stringQuickStart ${LANG_GERMAN} "Supplets Schnellstart Informationen anzeigen"
LangString stringQuickStart ${LANG_ENGLISH} "show Supplets quickstart informations"
LangString addrQuickStart ${LANG_GERMAN} "http://www.supplets.com/quickstart.html?deutsch"
LangString addrQuickStart ${LANG_ENGLISH} "http://www.supplets.com/quickstart.html?english"
LicenseLangString license2 ${LANG_GERMAN} "E:\progStuff\iePlugin\automation\current\licenseDeutsch.txt"
LicenseLangString license2 ${LANG_ENGLISH} "E:\progStuff\iePlugin\automation\current\licenseEnglish.txt"

#end Language specific data

; Script generated by the HM NIS Edit Script Wizard.

#begin special macro for DLL upgrade

; Macro - Upgrade DLL File
; Written by Joost Verburg
; ------------------------
;
; Parameters:
; LOCALFILE   - Location of the new DLL file (on the compiler system)
; DESTFILE    - Location of the DLL file that should be upgraded (on the user's system)
; TEMPBASEDIR - Directory on the user's system to store a temporary file when the system has
;               to be rebooted.
;               For Win9x support, this should be on the same volume as the DESTFILE!
;               The Windows temp directory could be located on any volume, so you cannot use
;               this directory.
;
; Define UPGRADEDLL_NOREGISTER if you want to upgrade a DLL that does not have to be registered.
;
; Note: If you want to support Win9x, you can only use short filenames (8.3).
;
; Example of usage:
; !insertmacro UpgradeDLL "dllname.dll" "$SYSDIR\dllname.dll" "$SYSDIR"
;

!macro UpgradeDLL LOCALFILE DESTFILE TEMPBASEDIR

  Push $R0
  Push $R1
  Push $R2
  Push $R3
  Push $R4
  Push $R5

  ;------------------------
  ;Unique number for labels

  !define UPGRADEDLL_UNIQUE ${__LINE__}

  ;------------------------
  ;Copy the parameters used on run-time to a variable
  ;This allows the usage of variables as paramter

  StrCpy $R4 "${DESTFILE}"
  StrCpy $R5 "${TEMPBASEDIR}"

  ;------------------------
  ;Check file and version

  IfFileExists $R4 0 upgradedll.copy_${UPGRADEDLL_UNIQUE}

  ClearErrors
    !define $R0 0
    !define $R1 0
    !define $R2 1
    !define $R3 1
# the follwing doesnt work, instead we always upgrade
#    GetDLLVersionLocal "${LOCALFILE}" $R0 $R1
#    GetDLLVersion $R4 $R2 $R3
  IfErrors upgradedll.upgrade_${UPGRADEDLL_UNIQUE}

#  IntCmpU $R0 $R2 0 upgradedll.done_${UPGRADEDLL_UNIQUE} upgradedll.upgrade_${UPGRADEDLL_UNIQUE}
#  IntCmpU $R1 $R3 upgradedll.done_${UPGRADEDLL_UNIQUE} upgradedll.done_${UPGRADEDLL_UNIQUE} \

    upgradedll.upgrade_${UPGRADEDLL_UNIQUE}

  ;------------------------
  ;Let's upgrade the DLL!

  SetOverwrite try

  upgradedll.upgrade_${UPGRADEDLL_UNIQUE}:
      ;Unregister the DLL
      UnRegDLL $R4
  ;------------------------
  ;Try to copy the DLL directly

  ClearErrors
    StrCpy $R0 $R4
    Call :upgradedll.file_${UPGRADEDLL_UNIQUE}
  IfErrors 0 upgradedll.noreboot_${UPGRADEDLL_UNIQUE}

  ;------------------------
  ;DLL is in use. Copy it to a temp file and Rename it on reboot.

  GetTempFileName $R0 $R5

    Call :upgradedll.file_${UPGRADEDLL_UNIQUE}
  Rename /REBOOTOK $R0 $R4

  ;------------------------
  ;Register the DLL on reboot

    WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\RunOnce" \
      "Register $R4" "$SYSDIR\REGSVR32.EXE $R4 /s"
    SetRebootFlag true

  Goto upgradedll.done_${UPGRADEDLL_UNIQUE}

  ;------------------------
  ;DLL does not exist - just extract

  upgradedll.copy_${UPGRADEDLL_UNIQUE}:
    StrCpy $R0 $R4
    Call :upgradedll.file_${UPGRADEDLL_UNIQUE}

  ;------------------------
  ;Register the DLL

  upgradedll.noreboot_${UPGRADEDLL_UNIQUE}:
    !ifndef UPGRADEDLL_NOREGISTER
      RegDLL $R4
    !endif

  ;------------------------
  ;Done

  upgradedll.done_${UPGRADEDLL_UNIQUE}:

  Pop $R5
  Pop $R4
  Pop $R3
  Pop $R2
  Pop $R1
  Pop $R0

  ;------------------------
  ;End

  Goto upgradedll.end_${UPGRADEDLL_UNIQUE}

  ;------------------------
  ;Called to extract the DLL

  upgradedll.file_${UPGRADEDLL_UNIQUE}:
    File /oname=$R0 "${LOCALFILE}"
    Return

  upgradedll.end_${UPGRADEDLL_UNIQUE}:

 ;------------------------
 ;Restore settings

 SetOverwrite lastused

 !undef UPGRADEDLL_UNIQUE

!macroend

#end special macro for DLL upgrade

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Supplets"
!define PRODUCT_VERSION "1.0"
!define PRODUCT_PUBLISHER "Panmental Software J. Knabe"
!define PRODUCT_WEB_SITE "http://www.supplets.com"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\Setup.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!define MUI_WELCOMEPAGE_TEXT $(welcome2)
!insertmacro MUI_PAGE_WELCOME
; License page
!define MUI_LICENSEPAGE_RADIOBUTTONS
!insertmacro MUI_PAGE_LICENSE $(license2)
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
#ExecShell "open" '"$R0"'
!define MUI_FINISHPAGE_SHOWREADME $(addrQuickStart)
!define MUI_FINISHPAGE_SHOWREADME_TEXT $(stringQuickStart)
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "German"

!insertmacro MUI_RESERVEFILE_LANGDLL
;--------------------------------
;Installer Functions

Function .onInit

  !insertmacro MUI_LANGDLL_DISPLAY

FunctionEnd

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "install.exe"
InstallDir "$PROGRAMFILES\Supplets"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "Hauptgruppe" SEC01
;Closing all IE Windows
loop:
    FindWindow $0 "IEFrame"
    IntCmp $0 0 done
    IsWindow $0 0 done
    System::Call 'user32::PostMessageA(i,i,i,i) i($0,${WM_CLOSE},0,0)'
    Sleep 100
    Goto loop
done:

  SetOutPath "$INSTDIR"
  SetOverwrite try
  File "E:\progStuff\iePlugin\automation\current\setup.exe"
  File "E:\progStuff\iePlugin\automation\current\supplets.dll"
  #begin register/upgrade the dll with macro
  !insertmacro UpgradeDLL "E:\progStuff\iePlugin\automation\current\supplets.dll" "$INSTDIR\supplets.dll" "$INSTDIR"
  #end register/upgrade the dll with macro
  File "E:\progStuff\iePlugin\automation\current\licenseDeutsch.txt"
  File "E:\progStuff\iePlugin\automation\current\licenseEnglish.txt"
  File "E:\progStuff\iePlugin\automation\current\supplets30000.hlp"
  File "E:\progStuff\iePlugin\automation\current\supplets20000.hlp"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\Setup.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\Setup.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  #begin register the setup.exe so that it will show up in IEs menu
  WriteRegStr HKLM "Software\Microsoft\Internet Explorer\Extensions\{8165030E-40EA-4D3E-B51C-B94616586954}" "CLSID" "{1FBA04EE-3024-11d2-8F1F-0000F87ABD16}"
  WriteRegStr HKLM "Software\Microsoft\Internet Explorer\Extensions\{8165030E-40EA-4D3E-B51C-B94616586954}" "MenuText" $(Suppletoptions)
  WriteRegStr HKLM "Software\Microsoft\Internet Explorer\Extensions\{8165030E-40EA-4D3E-B51C-B94616586954}" "MenuStatusBar" "Ermglicht, das Supplets-Plugin zu konfigurieren"
  WriteRegStr HKLM "Software\Microsoft\Internet Explorer\Extensions\{8165030E-40EA-4D3E-B51C-B94616586954}" "Exec" "$INSTDIR\Setup.exe"
  #end register the setup.exe so that it will show up in IEs menu
  #begin register the InstallDir and onlinehelp address
  WriteRegStr HKCU "Software\Microsoft\Internet Explorer\Explorer Bars\{0EC90553-9F39-4817-9F60-4231BE049C18}\ConfigData" "InstDir" "$INSTDIR"
  WriteRegStr HKCU "Software\Microsoft\Internet Explorer\Explorer Bars\{0EC90553-9F39-4817-9F60-4231BE049C18}\ConfigData" "onlinehelp" $(addrQuickStart)
  #end register the InstallDir
  #begin memorize language
  StrCmp "$(LangName)" "English" FoundEnglish FoundOther
  FoundEnglish:
    WriteRegStr HKCU "Software\Microsoft\Internet Explorer\Explorer Bars\{0EC90553-9F39-4817-9F60-4231BE049C18}\ConfigData" "Lang" "20000"
    Goto end
  FoundOther:
    WriteRegStr HKCU "Software\Microsoft\Internet Explorer\Explorer Bars\{0EC90553-9F39-4817-9F60-4231BE049C18}\ConfigData" "Lang" "30000"
  end:
  #end memorize language
SectionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) has been removed."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Uninstall $(^Name)?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  UnRegDLL "$INSTDIR\Supplets.dll"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\SUPPLETS.HLP"
  Delete "$INSTDIR\SUPPLETS.gid"
  Delete "$INSTDIR\SUPPLETS.fts"
  Delete "$INSTDIR\Supplets.dll"
  Delete "$INSTDIR\Setup.exe"

  RMDir "$INSTDIR"

  #begin delete configuration
  DeleteRegKey HKCU "Software\Microsoft\Internet Explorer\Explorer Bars\{0EC90553-9F39-4817-9F60-4231BE049C18}"
  #end delete configuration
  #begin delete setup.exe from IE menu
  DeleteRegKey HKLM "Software\Microsoft\Internet Explorer\Extensions\{8165030E-40EA-4D3E-B51C-B94616586954}"
  #end delete setup.exe from IE menu
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd
