unit fEnum;

interface

uses
  Dialogs, Messages, SysUtils, barUtil,
           Windows, ComObj, ComServ, myDialogs,
            Registry, MSHTML_TLB, SHDocVw_TLB, SHLOBJ,CommCtrl,Classes,ActiveX;

type

frameEnum=class(TObject)
  private
    base:IWebBrowser2;
    col:TList;
    current:integer;
    procedure getAll(frame:IWebBrowser2);
  public
    class function getScreenPos(forFrame:IWebBrowser2):TPoint;
    class function getBrowser(mainFrame:IWebBrowser2;forURL:wideString):IWebBrowser2;
    class procedure getTarget(frame:IWebBrowser2;target:wideString;var found:IWebBrowser2);
    constructor create(iFrame:IWebBrowser2);
    destructor Destroy(); override;
    function hasMore:boolean;
    function next:IWebBrowser2;
  end;

implementation

constructor frameEnum.create(iFrame:IWebBrowser2);
begin
inherited Create;
base:=iFrame;
//???   base._AddRef;
col:=TList.Create;
getAll(base);
current:=0;
col.Pack;
end;

function frameEnum.hasMore:boolean;
begin
result:=current<col.Count-1;
end;

function frameEnum.next:IWebBrowser2;
begin
result:=IWebBrowser2(col.items[current]);
inc(current);
end;

destructor frameEnum.Destroy();
begin
col.Clear;
col.Free;
col:=nil;
//???   base._Release;
inherited;
end;

class function frameEnum.getScreenPos(forFrame:IWebBrowser2):TPoint;
var
  temp:IhtmlDocument2;
  wind2:IHTMLWindow2;
  wind3:IHTMLWindow3;
  iDisp:IDispatch;
begin
result.x:=0;
result.y:=0;
if(forFrame=nil)then
  exit;
//MessageDlg('here0:'+forFrame.Get_LocationURL,mtError,[mbOk], 0);
iDisp:=forFrame.Get_document;
if(SUCCEEDED(iDisp.QueryInterface(IID_IHtmlDocument2,temp)))then
  begin
//  MessageDlg('here1',mtError,[mbOk], 0);
  wind2:=temp.Get_parentWindow;
//  MessageDlg('here2',mtError,[mbOk], 0);
  if(wind2<>nil)and(SUCCEEDED(wind2.QueryInterface(IID_IHtmlWindow3,wind3)))then
    begin
    result.x:=wind3.Get_screenLeft;
    result.y:=wind3.Get_screenTop;
//    MessageDlg('here3',mtError,[mbOk], 0);
//???       wind3._Release;
    end;
//grrr  temp._Release;
//  MessageDlg('here4',mtError,[mbOk], 0);
  end;
end;

class function frameEnum.getBrowser(mainFrame:IWebBrowser2;forURL:wideString):IWebBrowser2;
var
res:IWebBrowser2;
begin
res:=nil;
frameEnum.getTarget(mainFrame,forURL,res);
//MessageDlg('getBrowser fertig: '+res.Get_LocationURL,mtError,[mbOk], 0);
result:=res;
end;

class procedure frameEnum.getTarget(frame:IWebBrowser2;target:wideString;var found:IWebBrowser2);
var
lpDisp:IDispatch;
pContainer:IOleContainer;
hr:HResult;
pEnumerator:IEnumUnknown;
pUnk:IUnknown;
pBrowser:IWebBrowser2;
begin
lpDisp:=nil;
lpDisp:=frame.Get_Document;
if(Assigned(lpDisp))then
  begin
  if(frame.Get_LocationURL=target)then
    begin
//    MessageDlg('getBrowser: '+frame.Get_LocationURL+'#'+target,mtError,[mbOk], 0);
//???       frame._AddRef;
    found:=frame;
    exit;
    end;
  hr:=lpDisp.QueryInterface(IOLEContainer,pContainer);
  if(FAILED(hr))then
    begin
    MessageDlg('Internal error 0131',mtInformation,[mbOk], 0);
    exit;
    end;
  hr:=pContainer.EnumObjects(OLECONTF_EMBEDDINGS,pEnumerator);
  if(FAILED(hr))then
    begin
    MessageDlg('Internal error 0132',mtInformation,[mbOk], 0);
    exit;
    end;
//  pEnumerator.reset;
  while(found=nil)and(pEnumerator.Next(1,pUnk,nil)=S_OK)do
    begin
    if(pUnk<>nil)then
      begin
          hr:=pUnk.QueryInterface(IID_IWebBrowser2,pBrowser);
//          pUnk._Release;      //causes crash
          pUnk:=nil;
          if(SUCCEEDED(hr))then
            begin
            getTarget(pBrowser,target,found);
//???               pBrowser._Release;
            end
          else
            MessageDlg('Internal error 0137',mtInformation,[mbOk], 0);
      end
    else
      MessageDlg('=nil',mtInformation,[mbOk], 0);
    end;
  pEnumerator._Release;
  end;
end;

procedure frameEnum.getAll(frame:IWebBrowser2);
var
lpDisp:IDispatch;
pContainer:IOleContainer;
hr:HResult;
pEnumerator:IEnumUnknown;
pUnk:IUnknown;
pBrowser:IWebBrowser2;
begin
lpDisp:=nil;
lpDisp:=frame.Document;
if(Assigned(lpDisp))then
  begin
  col.add(pointer(frame));
//  MessageDlg(inttostr(integer(pointer(frame)))+' '+frame.Get_LocationURL,mtInformation,[mbOk], 0);
  hr:=lpDisp.QueryInterface(IOLEContainer,pContainer);
  if(FAILED(hr))then
    begin
    MessageDlg('Internal error 0131',mtInformation,[mbOk], 0);
    exit;
    end;
  hr:=pContainer.EnumObjects(OLECONTF_EMBEDDINGS,pEnumerator);
  if(FAILED(hr))then
    begin
    MessageDlg('Internal error 0132',mtInformation,[mbOk], 0);
    exit;
    end;
//  pEnumerator.reset;
  while(pEnumerator.Next(1,pUnk,nil)=S_OK)do
    begin
    if(pUnk<>nil)then
      begin
          hr:=pUnk.QueryInterface(IID_IWebBrowser2,pBrowser);
//          pUnk._Release;      //causes crash
          pUnk:=nil;
          if(SUCCEEDED(hr))then
            begin
            getAll(pBrowser);
//???               pBrowser._Release;
            end
          else
            MessageDlg('Internal error 0137',mtInformation,[mbOk], 0);
      end
    else
      MessageDlg('=nil',mtInformation,[mbOk], 0);
    end;
  pEnumerator._Release;
  end;
end;


end.
