unit mydialogs;

interface

uses
  Dialogs,
        //a lot is not needed:
  Messages, SysUtils,
  Windows, ActiveX, ComObj, ComServ,
  Forms,Registry, MSHTML_TLB, SHDocVw_TLB, SHLOBJ,CommCtrl,textdata, barutil
          ,Classes, Graphics, Controls,
  StdActns, ActnList, ToolWin,
  ExtCtrls, OleCtrls, StdCtrls, ImgList,  ComCtrls;

type

  MarkerStyle=record
    textcolor:string;
    backgroundcolor:string;
    effect:string;
    distance:string;
    position:String;
    bold:boolean;
    italics:boolean;
    end;
  NoteStyle=record
    linecolor:string;
    notecolor:string;
    linetype:string;
    linewidth:string;
    fSize:integer;
    fName:String;
    fBold:boolean;
    fItalic:boolean;
    end;

  valPair=record
    txt,show:string; //item value, shown
    no:integer; //internal representation number
    end;
TNote=class(TInterfacedObject)
  private
    helper: UInt;
    closeStr,deleteStr,scrollStr:wideString;
    closeToolTip,deleteToolTip,scrollToolTip:hwnd;
    screenlogPixels,closing,deleting,viewing:integer;
    creatorText:wideString;
    ownpar:HWND;
    DlgProcInst:TfarProc;
    theFont:HFONT;
    theCol:ColorRef;
    thecolBrush:HBrush;
    theCreatorFont:HFont;
    theDarkerCol:ColorRef;
    isInBar:boolean; //important var, says wether note can be moved,
                     //resized and closed
    function getFont:HFont;
    procedure setFont(newFont:HFont);
    function getCol:ColorRef;
    procedure setCol(newCol:ColorRef);
    function getCreatorString:wideString;
  public
    ownWind,editWind:HWND;
    ID,wantedTop:integer;
    myHolder:pointer;
    Text:wideString;
    constructor Create(myID:integer;myCreator,myText:wideString;myfont:HFONT;myCol:ColorRef;inBar:boolean;myownpar:HWND;holder:pointer);
    procedure updateText;
    procedure savePos;
    procedure show(initRect:tRect);
    procedure uninit;
    procedure adjustSize(PosX,PosY,widthX,widthY:integer);
    function DlgProc(wind:HWND;uid:UInt;wPar:WParam;lPar:LParam): LResult; stdcall;
    property daFont:HFont read getFont write setFont;
    property daCol:ColorRef read getCol write setCol;
    property CreatorString:wideString read getCreatorString;
  end;

        TMarkerStyleDialog = class(TInterfacedObject)
            private
distances:array[0..4] of valPair;
positions:array[0..4] of valPair;
effects: array[0..3] of valPair;
currentVals:MarkerStyle;
              ownpar:HWND;
              DlgProcInst:TfarProc;
              help:string;
              resNr:integer;
              textcol:TColorDialog;
              backgroundcol:TColorDialog;
              procedure getAll(wind:HWND;var where:MarkerStyle);
              procedure initAll(wind:HWND);
              procedure preview(wind:HWND);
            public
            vals:MarkerStyle;
            constructor Create(what:integer;initial:MarkerStyle;myownpar:HWND;helpfile:string);
            function execute:integer; //shows modal and returns 1/true if finished with OK
            function DlgProc(wind:HWND;uid:UInt;wPar:WParam;lPar:LParam): longbool; stdcall;
            end;
        TNoteStyleDialog = class(TInterfacedObject)
            private
linetypes:array[0..3] of valPair;
linewidths:array[0..4] of valPair;
currentVals:NoteStyle;
aNote:string;
someText:string;
              ownpar:HWND;
              help:string;
              resNr:integer;
              DlgProcInst:TfarProc;
              linecol:TColorDialog;
              notecol:TColorDialog;
              noteFont:TFontDialog;
              procedure getAll(wind:HWND;var where:NoteStyle);
              procedure initAll(wind:HWND);
              procedure preview(wind:HWND);
            public
            vals:NoteStyle;
            constructor Create(what:integer;initial:NoteStyle;myownpar:HWND;helpfile:String);
            function execute:integer; //shows modal and returns 1/true if finished with OK
            function DlgProc(wind:HWND;uid:UInt;wPar:WParam;lPar:LParam): longbool; stdcall;
            end;

function WebColorToDelphiColor(const AWebColor: string): TColor;
function DelphiColorToWebColor(const AColor: TColor): string;
function WebColorToRGB(what:string):ColorRef;

function CreateTooltip(wind:hwnd;what:wideString;myID:integer;rectangle:trect):hwnd;
procedure newToolTipRect(hwndTT:hwnd;myID:integer;ownerWind:hwnd;rectangle:TRect);
procedure killToolTip(hwndTT:hwnd;myID:integer;ownerWind:hwnd);

const
  darkening=60;
  NoteRes=600;
  StyleDlg_TeMa='TeMa';
  StyleDlg_altTeMa='altTeMa';
  StyleDlg_Note='Annote';
  StyleDlg_lineCol='line';
  StyleDlg_noteCol='note';
  StyleDlg_lineType='ltype';
  StyleDlg_lineWidth='lwidth';
  StyleDlg_fontName='fName';
  StyleDlg_fontSize='fSize';
  StyleDlg_fontItalic='fItalic';
  StyleDlg_fontBold='fBold';
  StyleDlg_text='text';
  StyleDlg_bg='bg';
  StyleDlg_dist='dist';
  StyleDlg_pos='pos';
  StyleDlg_effect='effect';
  StyleDlg_bold='bold';
  StyleDlg_italics='italics';

implementation

uses mark,myCol;

//var
//threadvar

function CreateTooltip(wind:hwnd;what:wideString;myID:integer;rectangle:trect):hwnd;
var
ti:TOOLINFO;
hwndTT:hwnd;
temp:string;
begin
InitCommonControl(ICC_WIN95_CLASSES);
//    GetClientRect (wind, rectangle);
temp:=what;
    hwndTT := CreateWindowEx(
        WS_EX_TOPMOST,
        TOOLTIPS_CLASS,
        Nil,
        WS_POPUP or TTS_NOPREFIX or TTS_ALWAYSTIP,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        wind,
        0,
        hInstance,
        Nil
        );
    SetWindowPos(hwndTT,
        HWND_TOPMOST,
        0,
        0,
        0,
        0,
        SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE);

    ti.cbSize := sizeof(TOOLINFO);
    ti.uFlags := TTF_SUBCLASS;
    ti.hwnd := wind;
    ti.hinst := hInstance;
    ti.uId := myID;
    ti.lpszText := PChar(temp);
    ti.rect.left := rectangle.left;
    ti.rect.top := rectangle.top;
    ti.rect.right := rectangle.right;
    ti.rect.bottom := rectangle.bottom;
    SendMessage(hwndTT, TTM_ADDTOOL, 0, LParam(@ti));
result:=hwndTT;
end;

procedure newToolTipRect(hwndTT:hwnd;myID:integer;ownerWind:hwnd;rectangle:TRect);
var
ti:TOOLINFO;
begin
    ti.cbSize := sizeof(TOOLINFO);
    ti.hwnd := ownerWind;
    ti.uId := myID;
    ti.rect.left := rectangle.left;
    ti.rect.top := rectangle.top;
    ti.rect.right := rectangle.right;
    ti.rect.bottom := rectangle.bottom;
    SendMessage(hwndTT, TTM_NEWTOOLRECT, 0, LParam(@ti));
end;

procedure killToolTip(hwndTT:hwnd;myID:integer;ownerWind:hwnd);
var
ti:TOOLINFO;
begin
    ti.cbSize := sizeof(TOOLINFO);
    ti.hwnd := ownerWind;
    ti.uId := myID;
    SendMessage(hwndTT, TTM_DELTOOL, 0, LParam(@ti));
end;

procedure windText(wind:HWND;resID:integer);
var
  loaded:array[0..50]of char;
begin
loadString(hInstance,resID,loaded,49);
SetWindowText(getDlgItem(wind,resID mod 1000),loaded);
end;

function WebColorToRGB(what:string):ColorRef;
begin
if(length(what)=7)then
  Result:=RGB(strtoint('$'+copy(what,2,2)),strtoint('$'+copy(what,4,2)),strtoint('$'+copy(what,6,2)))
else
  Result:=high(DWORD);
end;

{**
 * Converts a Delphi TColor to a HTML4 compatible sRGB color code.
 * e.g. clBlue will be converted to #0000FF
 * @param AColor A Delphi TColor to convert
 * @returns A HTML4 compatible Hex RGB code (with '#' prefix)
 *}
function DelphiColorToWebColor(const AColor: TColor): string;
var
  lRed : string;
  lGreen : string;
  lBlue : string;
  lRGB : string;
  i : Integer;
  lRGBLength : Integer;
begin
  lRGB := IntToHex(ColorToRGB(AColor), 0);
  lRGBLength := Length(lRGB);

  // Fill with zero's to the length of 6
  for i := 1 to (6 - lRGBLength) do
    lRGB := '0' + lRGB;

  lRed := Copy(lRGB, 5, 2);
  lGreen := Copy(lRGB, 3, 2);
  lBlue := Copy(lRGB, 1, 2);
  Result := '#' + lRed + lGreen + lBlue;
end;

{**
 * Converts a HTML4 compatible sRGB color code to a Delphi TColor
 * e.g. #0000FF (Blue) will be converted to $00FF0000
 * @param AWebColor A HTML4 compatible Hex RGB color code (with '#' prefix)
 * @returns A Delphi TColor to convert
 *}
function WebColorToDelphiColor(const AWebColor: string): TColor;
var
  lRed : Integer;
  lGreen : Integer;
  lBlue : Integer;
begin
  Result := clNone;

  if (Length(AWebColor) = 7) and (AWebColor[1] = '#') then
  begin
    lRed := StrToInt('$' + Copy(AWebColor, 2, 2));
    lGreen := StrToInt('$' + Copy(AWebColor, 4, 2));
    lBlue := StrToInt('$' + Copy(AWebColor, 6, 2));
    Result := TColor((lBlue * 65536) + (lGreen * 256) + lRed);
  end;
end;

procedure registerNoteClasses(update:boolean;theColBrush:HBrush);
var
  wc:WNDCLASS;
  dwStyle:dWord;
begin
    if(GetClassInfo(SysInit.HINSTANCE,'SuppletsNoteWind',wc))then
     if(update)then
      Windows.UnRegisterClass('SuppletsNoteWind',hinstance)
     else
      exit;
    ZeroMemory(@wc,sizeof(WNDCLASS));
    wc.style          := CS_SAVEBITS or CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW or CS_PARENTDC or CS_NOCLOSE or CS_DBLCLKS;//CS_HREDRAW or CS_VREDRAW or
    wc.lpfnWndProc    := @defWindowproc;
    wc.cbClsExtra     := 0;
    wc.cbWndExtra     := 0;
    wc.hInstance      := hInstance;
    wc.hIcon          := 0;
    wc.hCursor        := LoadCursor(integer(Nil), IDC_ARROW);
    wc.hbrBackground  := theColBrush;
    wc.lpszMenuName   := nil;
    wc.lpszClassName  := 'SuppletsNoteWind';
    if not(SUCCEEDED(Windows.RegisterClass(wc)))then
      begin
      MessageDlg('Error 109',mtInformation,[mbOk], 0);
      end;
end;

//begin of TNOTE
constructor TNote.Create(myID:integer;myCreator,myText:wideString;myFont:HFont;myCol:ColorRef;inBar:boolean;myownpar:HWND;holder:pointer);
Var
  wp:TMethod;
  dc:hdc;
begin
helper:=0;
inherited Create;
ownpar:=myOwnPar;
myHolder:=holder;
closeStr:='Close';
deleteStr:='Delete';
scrollStR:='scroll reference into view';
closing:=0;
deleting:=0;
viewing:=0;
wantedTop:=-1;
DC := GetDC(0);
ScreenLogPixels := GetDeviceCaps(DC, LOGPIXELSY);
ReleaseDC(0,DC);
CreatorText:=myCreator;
ID:=myID;
Text:=myText;
isInBar:=inBar;
theFont:=myFont;
theCol:=myCol;
theColBrush:=CreateSolidBrush(theCol);
theDarkerCol:=RGB(getRvalue(theCol)-darkening,getGvalue(theCol)-darkening,getBvalue(theCol)-darkening);
wp.code:=@TNote.DlgProc;
wp.data:=self;
DlgProcInst:=makeWndProcInstance(wp);
end;

function TNote.getCol:ColorRef;
begin
result:=theCol;
end;

procedure TNote.setCol(newCol:ColorRef);
begin
theCol:=newCol;
deleteObject(theColBrush);
theColBrush:=CreateSolidBrush(theCol);
theDarkerCol:=RGB(getRvalue(theCol)-darkening,getGvalue(theCol)-darkening,getBvalue(theCol)-darkening);
registerNoteClasses(true,theColBrush);
adjustSize(-1,-1,-1,-1);
InvalidateRect(editwind,nil,true);
end;

function TNote.getFont:HFont;
begin
result:=theFont;
end;

procedure TNote.setFont(newFont:HFont);
begin
theFont:=newFont;
SendMessage(editWind,WM_SETFONT,WParam(theFont),LParam(true));
end;

procedure TNote.show(initRect:tRect);
var
  y:String;
  w:widestring;
  dwStyle:dWord;
  rc:TRect;
  FontName:array[0..20] of Char;
begin
StrPCopy(FontName,'Arial');
theCreatorFont:=CreateFont(-MulDiv(8, ScreenLogPixels, 72),0,0,0,FW_Normal,1,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH or FF_SWISS,@FontName);
registerNoteClasses(true,theColBrush); //false would be better
                                        //but might lead to incosistencies
if(isInBar)then
  dwStyle:=WS_TABSTOP or WS_CLIPCHILDREN or WS_CHILD
else
  dwStyle :=WS_TABSTOP or WS_CLIPCHILDREN or WS_POPUP{ or WS_TABSTOP WS_CLIPSIBLINGS or };// or WS_CHILD;
ownWind := CreateWindowEx (WS_EX_TOOLWINDOW,
                'SuppletsNoteWind',   // Class name
                '',           // Window text
                dwStyle,        // Window style
                0,              // x-coordinate of the upper-left corner
                0,              // y-coordinate of the upper-left corner
                100,  // Width of the window for the edit
                                // control
                100,  // Height of the window for the edit
                                // control
                ownPar, // Window handle to the parent window
                0, // Control identifier
                hInstance,        // Instance handle
                NIL);
setwindowlong(ownWind,GWL_WNDPROC,longword(DlgProcInst));
dwStyle := WS_CHILD or ES_LEft or ES_MULTILINE or ES_AUTOVSCROLL;
editWind := CreateWindow (
                'EDIT',   // Class name
                '',           // Window text
                dwStyle,        // Window style
                0,              // x-coordinate of the upper-left corner
                0,              // y-coordinate of the upper-left corner
                100,  // Width of the window for the edit
                                // control
                100,  // Height of the window for the edit
                                // control
                ownWind,           // Window handle to the parent window
                0, // Control identifier
                hInstance,        // Instance handle
                NIL);
y:=text;
SendMessage(editwind,WM_SETTEXT,wParam(0),lParam(PChar(y)));
SendMessage(editWind,WM_SetFont,WParam(daFont),LParam(false));
SendMessage(editwind,EM_SETLIMITTEXT,wParam(512),lParam(0));
adjustSize(initRect.Left,initRect.Top,initRect.Right,initRect.Bottom);
if(not(isInBar))then
  begin
  GetClientRect(ownwind, rc);
  rc.Left:=rc.Right-15;
  dec(rc.Right,3);
  rc.Top:=4;
  rc.Bottom:=15;
  closeToolTip:=CreateTooltip(ownwind,closeStr,0,rc);
  dec(rc.Left,14);
  dec(rc.Right,14);
  deleteToolTip:=CreateTooltip(ownwind,deleteStr,1,rc);
  rc.Left:=3;
  rc.Right:=17;
  scrollToolTip:=CreateTooltip(ownwind,scrollStr,2,rc);
  end;
ShowWindow(ownwind,SW_SHOWNOACTIVATE);
ShowWindow(editwind,SW_SHOWNOACTIVATE);
end;

function TNote.getCreatorString:wideString;
begin
result:=CreatorText;
end;

//moves and/or resizes the note
procedure TNote.adjustSize(PosX,PosY,widthX,widthY:integer);
var
flags:UInt;
rec:trect;
i:integer;
minus:boolean;
begin
if(isInBar)then
  begin
  aNote(myHolder).refBoundRect:=aNote(myHolder).holder.getOuterBound(id);
  wantedTop:=aNote(myHolder).refBoundRect.Top;
  end;
flags:=SWP_NOZORDER or SWP_NOOWNERZORDER or SWP_NOACTIVATE or helper;
if(PosX<0)then
  begin
  if(not(isInBar))then
    flags:=flags or SWP_NOMOVE;
  PosX:=aNote(myHolder).lastPos.Left;
  end;
minus:=false;
if(widthX<0)or(widthY<0)then
  begin
  minus:=true;
  if(isInBar)then
    begin
    getclientrect(getParent(ownWind),rec);
    widthX:=rec.Right-4;
    getclientrect(ownWind,rec);
    widthY:=rec.Bottom;
    end
  else
    flags:=flags or SWP_NOSIZE;
  end;
 if(isInBar)and(myHolder<>nil)and(aNote(myHolder).holder<>nil)and(aNote(myHolder).holder.notes<>nil)then
  begin
  aNote(myHolder).holder.notes.pack;
  i:=aNote(myHolder).holder.notes.IndexOf(myHolder);
  if(wantedTop<>-1)then
    posY:=wantedTop;
  if(aNote(myHolder).holder.getPredNote(i)<>nil)then
    begin
    rec:=aNote(aNote(myHolder).holder.getPredNote(i).myHolder).lastPos;
    if(rec.Top<>0)then
      if(rec.top+rec.Bottom+4>PosY)then
        PosY:=max(rec.top+rec.Bottom+4,wantedTop);
    end;
 end;
setwindowpos(ownWind,HWND_NOTOPMOST,PosX,PosY,widthX,widthY,flags);
savePos;
 if(isInBar)and(myHolder<>nil)and(aNote(myHolder).holder<>nil)and(aNote(myHolder).holder.notes<>nil)then
  if(i<>-1)and(aNote(myHolder).holder.getSuccNote(i)<>nil)then
    begin
    rec:=aNote(aNote(myHolder).holder.getSuccNote(i).myHolder).lastpos;
    if(rec.Top<PosY+widthY+4)then
      aNote(myHolder).holder.getSuccNote(i).adjustSize(2,PosY+widthY+4,-1,-1)
    else
      aNote(myHolder).holder.getSuccNote(i).adjustSize(-10,-1,-1,-1);
    end;
getclientrect(ownWind,rec);
if(minus)then
  begin
  widthX:=rec.Right;
  widthY:=rec.Bottom;
  end;
if(not(isInBar))then
  moveWindow(editWind,1,17,widthX-2,widthY-31,false)
else
  moveWindow(editWind,1,1,widthX-2,widthY-15,false);
rec.Left:=8;
rec.Top:=6;
rec.Right:=widthX-rec.Left;
rec.Bottom:=widthY;
SendMessage(editwind,EM_SETRECT,wParam(0),lParam(@rec));
if(not(isInBar))then
  begin
  GetClientRect(ownwind, rec);
  rec.Left:=rec.Right-15;
  dec(rec.Right,3);
  rec.Top:=4;
  rec.Bottom:=15;
  newToolTipRect(closeToolTip,0,ownWind,rec);
  dec(rec.Left,14);
  dec(rec.Right,14);
  newToolTipRect(deleteToolTip,1,ownWind,rec);
  end;
InvalidateRect(ownwind,nil,true);
end;

procedure killMsg(holder:pointer);
begin
if(holder<>nil)then
  aNote(holder).visUninited;
end;

procedure TNote.savePos;
var
  y:tRect;
  z:integer;
  x:tPoint;
begin
if(isWindow(ownPar))then
  begin
  if(isInBar)then
    z:=aNote(myholder).lastPos.Right;
  getClientRect(ownWind,y);
  mapWindowPoints(ownWind,ownPar,y,1);
  if(isInBar)then
    y.Right:=z;
  aNote(myholder).lastPos:=y;
  end;
//MessageDlg('savePos '+inttostr(id)+' x:'+inttostr(y.left)+' y:'+inttostr(y.Top)+' wx:'+inttostr(y.Right)+' wy:'+inttostr(y.Bottom),mtInformation,[mbOk], 0);
end;

procedure TNote.updateText;
var
  x:array[0..1023]of char;
begin
  SendMessage(editWind,WM_GetText,WParam(1023),LParam(@x));
  Text:=X;
end;

procedure TNote.uninit;
begin
if(isWindow(ownWind))then
  begin
  updateText;
  if(not(isInBar))then
    begin
    killToolTip(closeToolTip,0,ownWind);
    killToolTip(deleteToolTip,1,ownWind);
    killToolTip(scrollToolTip,2,ownWind);
    end;
  savePos;
  showwindow(ownWind,SW_Hide);
  DestroyWindow(ownWind);
  freeWndProcInstance(DlgProcInst);
  deleteObject(theColBrush);
  deleteObject(theCreatorFont);
  end;
killMsg(myHolder);
end;

function TNote.DlgProc(wind:HWND;uid:UInt;wPar:WParam;lPar:LParam): LResult; stdcall;
var
  minmax:PMinMaxInfo;
  ps:TPaintStruct;
  rc,fillrc:trect;
  old,old2:HGDIOBJ;
  CreatorStr:array[0..90] of Char;
  tempBrush:HBrush;
begin
case uid of
  WM_SIZING:
    begin
    helper:=SWP_NOMOVE;
    Result:=DefWindowProc(wind,uid,wPar,lPar);
    end;
  WM_SIZE:
    begin
    if(wind=ownwind)then
      adjustsize(-1,-1,-1,-1);
    helper:=0;
    Result:=DefWindowProc(wind,uid,wPar,lPar);
    end;
  WM_LBUTTONDOWN:
   if(getCapture<>wind)then
    begin
    setCapture(wind);
    if(hiWord(lPar)>=4)and(hiWord(lPar)<=15)and(not(isInBar))then
     begin
     GetWindowRect(Wind,rc);
     if(loWord(lPar)>=rc.Right-rc.Left-15)and(loWord(lPar)<=rc.Right-rc.Left-3)then
      begin
      closing:=5;
      InvalidateRect(wind,nil,true);
      end
     else
     if(loWord(lPar)>=rc.Right-rc.Left-29)and(loWord(lPar)<=rc.Right-rc.Left-17)then
      begin
      deleting:=5;
      InvalidateRect(wind,nil,true);
      end
     else
     if(loWord(lPar)>=3)and(loWord(lPar)<=17)then
      begin
      viewing:=5;
      InvalidateRect(wind,nil,true);
      end;
     end
    else
     if(not(isInBar))then
      sendMessage(wind,WM_SYSCOMMAND,SC_SIZE or SC_MOVE,lPar)
     else
      sendMessage(wind,WM_SYSCOMMAND,SC_SIZE,lPar);
    Result:=DefWindowProc(wind,uid,wPar,lPar);
    end;
  WM_LBUTTONUP:
    begin
    if(getCapture=wind)then
      releaseCapture();
    if(hiWord(lPar)>=4)and(hiWord(lPar)<=15)and((closing<>0)or(deleting<>0)or(viewing<>0))then
      begin
      GetWindowRect(Wind,rc);
      if(loWord(lPar)>=rc.Right-rc.Left-15)and(loWord(lPar)<=rc.Right-rc.Left-3)and(closing=5)then
        begin
        uninit; //closing
        end
      else
      if(loWord(lPar)>=rc.Right-rc.Left-29)and(loWord(lPar)<=rc.Right-rc.Left-17)and(deleting=5)then
        begin
        if(myHolder<>nil)then
          aNote(myHolder).delete  //deleting
         else
          uninit;
        end
      else
      if(loWord(lPar)>=3)and(loWord(lPar)<=17)and(viewing=5)then
        begin
        if(myHolder<>nil)then
          aNote(myHolder).scrollIntoView(true);
        end
      else
        begin
        closing:=0;
        deleting:=0;
        InvalidateRect(wind,nil,true);
        end;
      end
      else
        begin
        closing:=0;
        deleting:=0;
        InvalidateRect(wind,nil,true);
        end;
    Result:=DefWindowProc(wind,uid,wPar,lPar);
    end;
  WM_LBUTTONDBLCLK:
    if(hiWord(lPar)>=4)and(hiWord(lPar)<=15)and(not(isInBar))then
      if(loWord(lPar)>=3)and(loWord(lPar)<=17)then
        begin
        uninit; //closing
        end;
  WM_NCHITTEST:
    begin
    Result:=DefWindowProc(wind,uid,wPar,lPar);
    GetWindowRect(Wind,rc);
    if(loWord(lPar)>rc.Right-14)and
      (hiWord(lPar)>rc.Bottom-14)then
     begin
     if(not(isInBar))then
      result:=HTBOTTOMRIGHT
     else
      result:=HTBOTTOM;
     end;
    if(hiWord(lPar)>rc.Top+2)and(hiWord(lPar)<rc.Top+16)and
       (loWord(lPar)>rc.Left+22)and(loWord(lPar)<rc.Right-32)and
       (not(isInBar))then
      result:=HTCAPTION;
    end;
  WM_PAINT:
    begin
    BeginPaint(Wind,ps);
    GetClientRect(Wind,rc);
    old:=selectObject(ps.hdc,CreatePen(PS_Solid,1,RGB(127,127,127)));
    movetoex(ps.hdc,0,rc.Bottom,nil);
    lineto(ps.hdc,0,0);
    lineto(ps.hdc,rc.Right,0);
    deleteObject(selectObject(ps.hdc,getStockObject(BLACK_PEN)));

old2:=SelectObject(ps.hdc,theCreatorFont);
//old:=SelectObject(ps.hdc,CreateSolidBrush(WebColorToRGB(x.notecolor)));
SetBkMode(ps.hdc, Transparent);
fillrc.Left:=10;
fillrc.Top:=rc.Bottom-13;
fillrc.Bottom:=rc.Bottom-1;
fillrc.Right:=rc.Right-15;
StrPCopy(CreatorStr,CreatorString);
drawtext(ps.hdc,CreatorStr,length(CreatorString),fillrc,DT_SINGLELINE or DT_VCENTER);
SelectObject(ps.hdc,old2);

    movetoex(ps.hdc,rc.Right-1,1,nil);
    lineto(ps.hdc,rc.Right-1,rc.Bottom-1);
    lineto(ps.hdc,0,rc.Bottom-1);
    //end frame / border
    //bkgd rectangle top, rectangle bottom
    if(not(isinBar))then
     begin
     fillrc.Left:=19;
     fillrc.Top:=3;
     fillrc.Right:=rc.Right-32;
     fillrc.Bottom:=16;
     if(not((getFocus=wind)or(getFocus=editwind)))then
      begin
      tempBrush:=CreateSolidBrush(theDarkerCol);
      FillRect(ps.hdc,fillrc,tempBrush);
      deleteObject(tempBrush);
      end
     else
      begin
      tempBrush:=CreateSolidBrush(GetSysColor(COLOR_ACTIVECAPTION));
      FillRect(ps.hdc,fillrc,tempBrush);
      deleteObject(tempBrush);
      end;
     end;
    //begin sizebox
    deleteObject(selectObject(ps.hdc,CreatePen(PS_Solid,1,theDarkerCol)));
    moveToEx(ps.hdc,rc.Right-14,rc.Bottom-2,nil);
    lineto(ps.hdc,rc.Right-2,rc.Bottom-14);
    moveToEx(ps.hdc,rc.Right-11,rc.Bottom-2,nil);
    lineto(ps.hdc,rc.Right-2,rc.Bottom-11);
    moveToEx(ps.hdc,rc.Right-8,rc.Bottom-2,nil);
    lineto(ps.hdc,rc.Right-2,rc.Bottom-8);
    moveToEx(ps.hdc,10,rc.Bottom-14,nil);
    lineto(ps.hdc,rc.Right-11,rc.Bottom-14);
    deleteObject(selectObject(ps.hdc,old));
    if(not(isInBar))then
      begin
      drawIconEx(ps.hdc,3,3,LoadImage(hinstance,makeintresource(13992),IMAGE_ICON,0,0,LR_SHARED),0,0,0,0,DI_NORMAL);
      drawIconEx(ps.hdc,rc.Right-15,4,LoadImage(hinstance,makeintresource(13991+closing),IMAGE_ICON,0,0,LR_SHARED),0,0,0,0,DI_NORMAL);
      drawIconEx(ps.hdc,rc.Right-29,4,LoadImage(hinstance,makeintresource(13990+deleting),IMAGE_ICON,0,0,LR_SHARED),0,0,0,0,DI_NORMAL);
      end;
    EndPaint(Wind,ps);
    Result:=DefWindowProc(wind,uid,wPar,lPar);
    end;
  WM_COMMAND:
    begin
    if(HiWord(wPar)=EN_SETFOCUS)then
      InvalidateRect(wind,nil,true);
    if(HiWord(wPar)=EN_KillFOCUS)then
      InvalidateRect(wind,nil,true);
    if(hiword(wPar)=EN_UPDATE)then
      InvalidateRect(editwind,nil,true);
    if(hiword(wPar)=EN_HSCROLL)then
      InvalidateRect(editwind,nil,true);
    if(hiword(wPar)=EN_VSCROLL)then
      InvalidateRect(editwind,nil,true);
       Result:=DefWindowProc(wind,uid,wPar,lPar);
    end;
  WM_SETFOCUS:
    begin
    //InvalidateRect(wind,nil,true);
    setfocus(editWind);
//    showwindow(editWind,SW_SHOW);
    Result:=DefWindowProc(wind,uid,wPar,lPar);
    end;
  WM_KILLFOCUS:
    begin
    InvalidateRect(editwind,nil,true);
    Result:=DefWindowProc(wind,uid,wPar,lPar);
    end;
  WM_GETMINMAXINFO:
    begin
    minmax:=Pointer(lPar);
    minmax.ptMinTrackSize.x:=60;
    minmax.ptMinTrackSize.y:=60;
    minmax.ptMaxTrackSize.x:=600;
    minmax.ptMaxTrackSize.y:=400;
    result:=0;
    end;
  WM_CTLCOLOREDIT:
    begin
    setBkMode(wPar,TRANSPARENT);
    result:=theColBrush;
    end;
  else
   Result:=DefWindowProc(wind,uid,wPar,lPar);
  end;
end;
//end of TNOTE

//begin of TMARKERSTYLEDIALOG
constructor TMarkerStyleDialog.Create(what:integer;initial:MarkerStyle;myownpar:HWND;helpFile:string);
Var
  wp:TMethod;
  tempInt:integer;
  loaded:array[0..50]of char;
begin
inherited Create;
ownpar:=myownpar;
resNr:=what;
help:=helpfile;
//TMarker(marker).clearModeless;
wp.code:=@TMarkerStyleDialog.DlgProc;
wp.data:=self;
DlgProcInst:=makeWndProcInstance(wp);
distances[0].txt:='-2';
distances[1].txt:='-1';
distances[2].txt:='0';
distances[3].txt:='+1';
distances[4].txt:='+2';
positions[0].txt:='-2';
positions[1].txt:='-1';
positions[2].txt:='0';
positions[3].txt:='+1';
positions[4].txt:='+2';
effects[0].txt:='none';
effects[1].txt:='overline';
effects[2].txt:='line-through';
effects[3].txt:='underline';
for tempInt:=0 to 3 do
  begin
  loadString(hInstance,2040+tempInt,loaded,49);
  effects[tempInt].show:=loaded;
  end;
textcol:=TColorDialog.Create(nil);
textcol.Options:=[cdFullOpen,cdAnyColor];
backgroundcol:=TColorDialog.Create(nil);
backgroundcol.Options:=[cdFullOpen,cdAnyColor];
currentVals.textcolor:=initial.textcolor;
currentVals.backgroundcolor:=initial.backgroundcolor;
currentVals.effect:=initial.effect;
currentVals.distance:=initial.distance;
currentVals.position:=initial.position;
currentVals.bold:=initial.bold;
currentVals.italics:=initial.italics;
end;

//shows modal and returns true if finished with OK
function TMarkerStyleDialog.execute:integer;
begin
Result:=DialogBox(hInstance, MAKEINTRESOURCE(resNr), ownpar, DlgProcInst);
textcol.Free;
backgroundcol.Free;
freeWndProcInstance(DlgProcInst);
end;

procedure TMarkerStyleDialog.initAll(wind:HWND);
var
  tempInt:integer;
  selVal:integer;
  loaded:array[0..50]of char;
begin
loadString(hInstance,2000,loaded,49);
SetWindowText(wind,loaded);
windText(wind,2101);
windText(wind,2102);
windText(wind,2103);
windText(wind,2402);
windText(wind,2403);
windText(wind,2404);
windText(wind,2406);
windText(wind,2407);
windText(wind,2408);
windText(wind,2409);
windText(wind,412);
windText(wind,415);
windText(wind,416);
if(CurrentVals.textcolor='#')then
  begin
  SendMessage(getDlgItem(wind,112),BM_SETCHECK,BST_UNCHECKED,0);
  enablewindow(getDlgItem(wind,102),false);
  textcol.color:=clNone;
  end
else
  begin
  SendMessage(getDlgItem(wind,112),BM_SETCHECK,BST_CHECKED,0);
  textcol.color:=WebColorToDelphiColor(currentVals.textcolor);
  end;
//init backgroundcolor
if(CurrentVals.backgroundcolor='#')then
  begin
  SendMessage(getDlgItem(wind,113),BM_SETCHECK,BST_UNCHECKED,0);
  enablewindow(getDlgItem(wind,103),false);
  backgroundcol.color:=clNone;
  end
else
  begin
  SendMessage(getDlgItem(wind,113),BM_SETCHECK,BST_CHECKED,0);
  backgroundcol.color:=WebColorToDelphiColor(currentVals.backgroundcolor);
  end;
//init effects:
selVal:=-99;
for tempInt:=0 to length(effects)-1 do
  begin
  effects[tempInt].no:=SendMessage(getDlgItem(wind,405),CB_ADDSTRING,0,integer(PChar(effects[tempInt].show)));
  if(currentVals.effect=effects[tempInt].txt)then
    selVal:=effects[tempInt].no;
  end;
if(selVal=-99)then
  selVal:=effects[0].no; //'none' is default
SendMessage(getDlgItem(wind,405),CB_SETCURSEL,selVal,0);
//init distance:
selVal:=-99;
for tempInt:=0 to length(distances)-1 do
  begin
  distances[tempInt].no:=SendMessage(getDlgItem(wind,410),CB_ADDSTRING,0,integer(PChar(distances[tempInt].txt)));
  if(currentVals.distance=distances[tempInt].txt)then
    selVal:=distances[tempInt].no;
  end;
if(selVal=-99)then
  selVal:=distances[2].no; //'0' is default
SendMessage(getDlgItem(wind,410),CB_SETCURSEL,selVal,0);
//init position:
selVal:=-99;
for tempInt:=0 to length(positions)-1 do
  begin
  positions[tempInt].no:=SendMessage(getDlgItem(wind,411),CB_ADDSTRING,0,integer(PChar(positions[tempInt].txt)));
  if(currentVals.position=positions[tempInt].txt)then
    selVal:=positions[tempInt].no;
  end;
if(selVal=-99)then
  selVal:=positions[2].no; //'0' is default
SendMessage(getDlgItem(wind,411),CB_SETCURSEL,selVal,0);
//bold Checker
if(CurrentVals.bold)then
  SendMessage(getDlgItem(wind,403),BM_SETCHECK,BST_CHECKED,0)
else
  SendMessage(getDlgItem(wind,403),BM_SETCHECK,BST_UNCHECKED,0);
//italics Checker
if(CurrentVals.italics)then
  SendMessage(getDlgItem(wind,404),BM_SETCHECK,BST_CHECKED,0)
else
  SendMessage(getDlgItem(wind,404),BM_SETCHECK,BST_UNCHECKED,0);

end;

procedure TMarkerStyleDialog.getAll(wind:HWND;var where:MarkerStyle);
begin
where.effect:=effects[SendMessage(getDlgItem(wind,405),CB_GETCURSEL,0,0)].txt;
where.distance:=distances[SendMessage(getDlgItem(wind,410),CB_GETCURSEL,0,0)].txt;
where.position:=positions[SendMessage(getDlgItem(wind,411),CB_GETCURSEL,0,0)].txt;
if(SendMessage(getDlgItem(wind,403),BM_GETCHECK,0,0)=BST_CHECKED)then
  where.bold:=true
else
  where.bold:=false;
if(SendMessage(getDlgItem(wind,404),BM_GETCHECK,0,0)=BST_CHECKED)then
  where.italics:=true
else
  where.italics:=false;
if(IsWindowEnabled(getDlgItem(wind,102)))then
  where.textcolor:=DelphiColorToWebColor(textcol.Color)
else
  where.textcolor:='#';
if(IsWindowEnabled(getDlgItem(wind,103)))then
  where.backgroundcolor:=DelphiColorToWebColor(backgroundcol.Color)
else
  where.backgroundcolor:='#';
end;

procedure TMarkerStyleDialog.preview(wind:HWND);
var
  x:MarkerStyle;
  ps:TPaintStruct;
  rc,leftLine,rightLine:trect;
  metric:TEXTMETRIC;
  mySize:Size;
  tempCol:ColorRef;
  FontName:array[0..30]of char;
  strike,bold,under:cardinal;
  old:HGDIOBJ;
  tempInt:integer;
begin
getAll(wind,x);
BeginPaint(Wind,ps);
GetWindowRect(Wind,rc);
GetWindowRect(getDlgItem(wind,413),leftLine);
GetWindowRect(getDlgItem(wind,414),rightLine);
dec(leftLine.Left,rc.Left);
dec(leftLine.Top,rc.Top);
dec(leftLine.Right,rc.Left);
dec(leftLine.Bottom,rc.Top);
dec(rightLine.Left,rc.Left);
dec(rightLine.Top,rc.Top);
dec(rightLine.Right,rc.Left);
dec(rightLine.Bottom,rc.Top);
tempCol:=WebColorToRGB(x.backgroundcolor);
if(tempCol<>high(DWORD))then
  SetBkColor(ps.hdc, tempCol);
tempCol:=WebColorToRGB(x.textcolor);
if(tempCol<>high(DWORD))then
  SetTextColor(ps.hdc, tempCol);
GetTextMetrics(ps.hdc,metric);
//GetTextFace(ps.hdc,49,FontName);
FontName:='MS Sans Serif';
if(x.bold)then
  bold:=FW_Bold
else
  bold:=FW_Normal;
if(x.effect=effects[3].txt)then //underline
  under:=cardinal(true)
else
  under:=cardinal(false);
if(x.effect=effects[2].txt)then //line-through
  strike:=cardinal(true)
else
  strike:=cardinal(false);
old:=SelectObject(ps.hdc,CreateFont(metric.tmHeight,metric.tmAveCharWidth,
0,0,bold,cardinal(x.italics),under,strike,
ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,metric.tmPitchAndFamily,@FontName));
SetBkMode(ps.hdc, Opaque);
SetTextCharacterExtra(ps.hdc,strtoint(x.distance));
SetTextAlign(ps.hdc,TA_BaseLine);
GetTextMetrics(ps.hdc,metric);
rc.left:=leftLine.Right;
rc.Top:=leftLine.Top-metric.tmHeight+strtoint(x.position);
rc.Right:=rightLine.Left-3;
rc.Bottom:=leftLine.Top+strtoint(x.position);
drawText(ps.hdc,PChar('Abcdef'),6,rc,DT_SingleLine or DT_VCenter or DT_Center or DT_NoClip);
GetTextExtentPoint32(ps.hdc,PChar('Abcdef'),6,mysize);
selectObject(ps.hdc,old);
if(x.effect=effects[1].txt)then //overline
  begin
  if(tempCol<>high(ColorRef))then
    old:=selectObject(ps.hdc,CreatePen(PS_Solid,1,tempCol))
  else
    old:=selectObject(ps.hdc,CreatePen(PS_Solid,1,RGB(0,0,0)));
  tempInt:=(rc.right-rc.left-mySize.cx) div 2;
  movetoex(ps.hdc,rc.left+tempInt,rc.top-metric.tmHeight+4,nil);
  lineto(ps.hdc,rc.Right-tempInt,rc.Top-metric.tmHeight+4);//BF_Flat or BF_Middle);
  selectObject(ps.hdc,old);
  end;
EndPaint(Wind,ps);
end;

function TMarkerStyleDialog.DlgProc(wind:HWND;uid:UInt;wPar:WParam;lPar:LParam): longbool; stdcall;
var
  x:^helpinfo;
begin
result:=false;
case uid of
  WM_Help:
   begin
   x:=pointer(lpar);
   if(x.iCtrlId<>0)then
     WinHelp(wind, PChar(help), HELP_CONTEXTPOPUP, 1000*resNr+x.iCtrlId);
   //MessageDlg('help received: '+inttostr(x.iCtrlId)+' '+inttostr(x.hItemHandle)+' '+inttostr(x.dwContextId),mtInformation,[mbOk], 0);
   end;
  WM_Paint:
   preview(wind);
  WM_INITDIALOG:
    begin
    initAll(wind);
    result:=true;
    end;
  WM_CLOSE:
    begin
    result:=true;
    if(wPar=1)and(lPar=1)then
      begin
      getAll(wind,vals);
      EndDialog(wind,1);
      end
    else
      EndDialog(wind,0);
    end;
  WM_COMMAND:
    begin
//    MessageDlg('cmd received: '+inttostr(uid)+' '+inttostr(wPar)+' '+inttostr(lPar),mtInformation,[mbOk], 0);
    case wPar of
      IDOK,IDYES,415:
        begin
        result:=true;
        SendMessage(wind,WM_CLOSE,1,1);
        Exit;
        end;
      IDCANCEL,IDABORT,IDCLOSE,IDNO,416:
        begin
        result:=true;
        SendMessage(wind,WM_CLOSE,0,0);
        Exit;
        end;
      112:
      if(IsWindowEnabled(getDlgItem(wind,102)))then
        begin
        SendMessage(getDlgItem(wind,112),BM_SETCHECK,BST_UNCHECKED,0);
        enablewindow(getDlgItem(wind,102),false);
        textcol.color:=clNone;
        end
      else
        begin
        SendMessage(getDlgItem(wind,112),BM_SETCHECK,BST_CHECKED,0);
        enablewindow(getDlgItem(wind,102),true);
        if(currentVals.textcolor='')then
          textcol.execute
        else
          textcol.color:=WebColorToDelphiColor(currentVals.textcolor);
        end;
      113:
      if(IsWindowEnabled(getDlgItem(wind,103)))then
        begin
        SendMessage(getDlgItem(wind,113),BM_SETCHECK,BST_UNCHECKED,0);
        enablewindow(getDlgItem(wind,103),false);
        backgroundcol.color:=clNone;
        end
      else
        begin
        SendMessage(getDlgItem(wind,113),BM_SETCHECK,BST_CHECKED,0);
        enablewindow(getDlgItem(wind,103),true);
        if(currentVals.backgroundcolor='')then
          backgroundcol.execute
        else
          backgroundcol.color:=WebColorToDelphiColor(currentVals.backgroundcolor);
        end;
      102:
        textcol.Execute;
      103:
        backgroundcol.Execute;
      end;
    InvalidateRect(wind,nil,true);
    end; //WM_COMMAND
  end; //CASE
end;
//end of TMARKERSTYLEDIALOG

//########################################################
//########################################################
//########################################################

//begin of TNOTESTYLEDIALOG
constructor TNoteStyleDialog.Create(what:integer;initial:NoteStyle;myownpar:HWND;helpfile:String);
Var
  wp:TMethod;
  loaded:array[0..50]of char;
  tempInt:integer;
begin
inherited Create;
ownpar:=myownpar;
help:=helpFile;
resNr:=what;
//TMarker(marker).clearModeless;
wp.code:=@TNoteStyleDialog.DlgProc;
wp.data:=self;
DlgProcInst:=makeWndProcInstance(wp);
linewidths[0].txt:='0';
linewidths[1].txt:='1';
linewidths[2].txt:='2';
linewidths[3].txt:='3';
linewidths[4].txt:='4';
linetypes[0].txt:='solid';
linetypes[1].txt:='dotted';
linetypes[2].txt:='dashed';
linetypes[3].txt:='double';
for tempInt:=0 to 3 do
  begin
  loadString(hInstance,3040+tempInt,loaded,49);
  linetypes[tempInt].show:=loaded;
  end;
loadString(hInstance,3050,loaded,49);
aNote:=loaded;
loadString(hInstance,3051,loaded,49);
someText:=loaded;

linecol:=TColorDialog.Create(nil);
linecol.Options:=[cdFullOpen,cdAnyColor];
notecol:=TColorDialog.Create(nil);
notecol.Options:=[cdFullOpen,cdAnyColor];
noteFont:=TFontDialog.Create(nil);
noteFont.MaxFontSize:=14;
noteFont.MinFontSize:=6;
noteFont.Options:=[fdLimitSize,fdAnsiOnly,fdForceFontExist];
currentVals.linecolor:=initial.linecolor;
currentVals.notecolor:=initial.notecolor;
currentVals.linetype:=initial.linetype;
currentVals.linewidth:=initial.linewidth;
currentVals.fSize:=initial.fSize;
currentVals.fName:=initial.fName;
currentVals.fBold:=initial.fBold;
currentVals.fItalic:=initial.fItalic;
end;

//shows modal and returns true if finished with OK
function TNoteStyleDialog.execute:integer;
begin
Result:=DialogBox(hInstance, MAKEINTRESOURCE(resNr), ownpar, DlgProcInst);
linecol.Free;
notecol.Free;
noteFont.Free;
freeWndProcInstance(DlgProcInst);
end;

procedure TNoteStyleDialog.initAll(wind:HWND);
var
  tempInt:integer;
  selVal:integer;
  loaded:array[0..50]of char;
begin
loadString(hInstance,3000,loaded,49);
SetWindowText(wind,loaded);
windText(wind,3101);
windText(wind,3102);
windText(wind,3408);
windText(wind,3409);
windText(wind,3301);
windText(wind,3302);
windText(wind,3402);
windText(wind,412);
windText(wind,415);
windText(wind,416);
//init linecolor
if(length(CurrentVals.linecolor)<>7)then
  CurrentVals.lineColor:='#33CC33';
linecol.Color:=WebColorToDelphiColor(CurrentVals.lineColor);
//init backgroundcolor
if(length(CurrentVals.notecolor)<>7)then
  CurrentVals.notecolor:='#FFFF99';
notecol.Color:=WebColorToDelphiColor(CurrentVals.notecolor);
noteFont.font.size:=CurrentVals.fSize;
noteFont.font.Name:=CurrentVals.fName;
if(CurrentVals.fBold)then
  noteFont.font.Style:=[fsBold];
if(CurrentVals.fItalic)then
  noteFont.font.Style:=[fsItalic];
if(CurrentVals.fBold)and(CurrentVals.fItalic)then
  noteFont.font.Style:=[fsBold,fsItalic];
//init lineTypes:
selVal:=-99;
for tempInt:=0 to length(lineTypes)-1 do
  begin
  lineTypes[tempInt].no:=SendMessage(getDlgItem(wind,410),CB_ADDSTRING,0,integer(PChar(lineTypes[tempInt].show)));
  if(currentVals.lineType=lineTypes[tempInt].txt)then
    selVal:=lineTypes[tempInt].no;
  end;
if(selVal=-99)then
  selVal:=lineTypes[2].no; //'dashed' is default
SendMessage(getDlgItem(wind,410),CB_SETCURSEL,selVal,0);
//init lineWidths:
selVal:=-99;
for tempInt:=0 to length(lineWidths)-1 do
  begin
  linewidths[tempInt].no:=SendMessage(getDlgItem(wind,411),CB_ADDSTRING,0,integer(PChar(lineWidths[tempInt].txt)));
  if(currentVals.lineWidth=lineWidths[tempInt].txt)then
    selVal:=lineWidths[tempInt].no;
  end;
if(selVal=-99)then
  selVal:=lineWidths[1].no; //'1' is default
SendMessage(getDlgItem(wind,411),CB_SETCURSEL,selVal,0);
end;

procedure TNoteStyleDialog.getAll(wind:HWND;var where:NoteStyle);
begin
where.linetype:=lineTypes[SendMessage(getDlgItem(wind,410),CB_GETCURSEL,0,0)].txt;
where.linewidth:=lineWidths[SendMessage(getDlgItem(wind,411),CB_GETCURSEL,0,0)].txt;
where.linecolor:=DelphiColorToWebColor(linecol.Color);
where.notecolor:=DelphiColorToWebColor(notecol.Color);
where.fSize:=noteFont.font.size;
where.fName:=noteFont.Font.Name;
if(fsBold in noteFont.Font.Style)then
  where.fBold:=true
else
  where.fBold:=false;
if(fsItalic in noteFont.Font.Style)then
  where.fItalic:=true
else
  where.fItalic:=false;
end;

procedure TNoteStyleDialog.preview(wind:HWND);
var
  x:NoteStyle;
  ps:TPaintStruct;
  rc,noteRect,textLine:trect;
  metric:TEXTMETRIC;
  mySize:Size;
//  tempCol:ColorRef;
  FontName:array[0..40]of char;
  tempInt,tempInt2,ScreenLogPixels:integer;
  old,old2,old3:HGDIOBJ;
  DC: HDC;

begin
BeginPaint(wind,ps);
EndPaint(wind,ps);

getAll(wind,x);
GetWindowRect(Wind,rc);
GetClientRect(getDlgItem(wind,303),noteRect);
BeginPaint(getDlgItem(wind,303),ps);
GetTextMetrics(ps.hdc,metric);
tempInt:=0;
while((tempInt<40)and(tempInt<length(x.fName)))do
  begin
  FontName[tempInt]:=x.fName[tempInt+1];
  inc(tempInt);
  end;
FontName[tempInt]:=char(0);

DC := GetDC(0);
ScreenLogPixels := GetDeviceCaps(DC, LOGPIXELSY);
ReleaseDC(0,DC);

if(x.fBold)then
  tempInt:=FW_BOLD
else
  tempInt:=FW_Normal;
old3:=SelectObject(ps.hdc,CreateFont(-MulDiv(x.fSize, ScreenLogPixels, 72),0,0,0,tempInt,dword(x.fItalic),0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,metric.tmPitchAndFamily,@FontName));

old:=SelectObject(ps.hdc,CreateSolidBrush(WebColorToRGB(x.notecolor)));
old2:=SelectObject(ps.hdc,CreatePen(PS_Solid,1,RGB(0,0,0)));
Rectangle(ps.hdc,noteRect.left,noteRect.Top,noteRect.Right,noteRect.Bottom);
SetBkMode(ps.hdc, Transparent);
inc(noteRect.left,2);
inc(noteRect.Top);
dec(noteRect.Right);
dec(noteRect.Bottom);
drawtext(ps.hdc,PChar(aNote),length(aNote),noterect,DT_SINGLELINE);
DeleteObject(SelectObject(ps.hdc,old));
DeleteObject(SelectObject(ps.hdc,old2));
DeleteObject(SelectObject(ps.hdc,old3));
EndPaint(getDlgItem(wind,303),ps);

GetClientRect(getDlgItem(wind,304),textLine);
BeginPaint(getDlgItem(wind,304),ps);

GetTextMetrics(ps.hdc,metric);
FontName:='MS Sans Serif';

old3:=SelectObject(ps.hdc,CreateFont(metric.tmHeight,metric.tmAveCharWidth,
0,0,FW_Normal,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,metric.tmPitchAndFamily,@FontName));
old:=SelectObject(ps.hdc,CreateSolidBrush(WebColorToRGB(x.notecolor)));
old2:=SelectObject(ps.hdc,CreatePen(PS_Solid,1,RGB(0,0,0)));
SetBkMode(ps.hdc, Transparent);
textLine.Top:=textLine.Bottom-metric.tmHeight;
drawtext(ps.hdc,PChar(sometext),length(someText),textLine,DT_NOCLIP or DT_CENTER or DT_SINGLELINE or DT_VCENTER);
GetTextExtentPoint32(ps.hdc,PChar(sometext),length(someText),mysize);
tempInt:=(textLine.Right-textLine.Left-mysize.cx) div 2;
inc(textLine.Left,tempInt);
dec(textLine.Right,tempInt);
dec(textLine.Bottom,2);
if(x.linetype='solid')or(x.lineType='double')then tempInt2:=PS_Solid;
if(x.linetype='dotted')then tempInt2:=PS_Dot;
if(x.linetype='dashed')then tempInt2:=PS_Dash;
SelectObject(ps.hdc,CreatePen(tempInt2,1,WebColorToRGB(x.linecolor)));
for tempInt:=strtoint(x.linewidth) downto 1 do
  if(x.lineType<>'double')or(tempInt<>2)then
    begin
    movetoex(ps.hdc,textLine.left,textLine.Bottom+tempInt,nil);
    lineto(ps.hdc,textLine.right,textLine.Bottom+tempInt);//BF_Flat or BF_Middle);
    end;
DeleteObject(SelectObject(ps.hdc,old));
DeleteObject(SelectObject(ps.hdc,old2));
DeleteObject(SelectObject(ps.hdc,old3));
EndPaint(getDlgItem(wind,304),ps);
end;

function TNoteStyleDialog.DlgProc(wind:HWND;uid:UInt;wPar:WParam;lPar:LParam): longbool; stdcall;
var
  x:^helpinfo;
begin
result:=false;
case uid of
  WM_Help:
   begin
   x:=pointer(lpar);
   if(x.iCtrlId<>0)then
     WinHelp(wind, PChar(help), HELP_CONTEXTPOPUP, 1000*resNr+x.iCtrlId);
   //MessageDlg('help received: '+inttostr(x.iCtrlId)+' '+inttostr(x.hItemHandle)+' '+inttostr(x.dwContextId),mtInformation,[mbOk], 0);
   end;
  WM_Paint:
   preview(wind);
  WM_INITDIALOG:
    begin
    initAll(wind);
    result:=true;
    end;
  WM_CLOSE:
    begin
//    MessageDlg('close received: '+inttostr(uid)+' '+inttostr(wPar)+' '+inttostr(lPar),mtInformation,[mbOk], 0);
    result:=true;
    if(wPar=1)and(lPar=1)then
      begin
      getAll(wind,vals);
      EndDialog(wind,1);
      end
    else
      EndDialog(wind,0);
    end;
  WM_COMMAND:
    begin
//    MessageDlg('cmd received: '+inttostr(uid)+' '+inttostr(wPar)+' '+inttostr(lPar),mtInformation,[mbOk], 0);
    case wPar of
      IDOK,IDYES,415:
        begin
        result:=true;
        SendMessage(wind,WM_CLOSE,1,1);
        Exit;
        end;
      IDCANCEL,IDABORT,IDCLOSE,IDNO,416:
        begin
        result:=true;
        SendMessage(wind,WM_CLOSE,0,0);
        Exit;
        end;
      102:
        linecol.execute;
      302:
        notecol.Execute;
      402:
        notefont.Execute;
      end;
    InvalidateRect(wind,nil,true);
    end; //WM_COMMAND
  end; //CASE
end;
//end of TNOTESTYLEDIALOG

end.

