unit savo;

interface

uses
  Classes,myCol,SuppletOpts,
  //a lot is not needed:
  Dialogs, Messages, SysUtils,
  Windows, ActiveX, ComObj, ComServ,
  Forms,Registry, MSHTML_TLB, SHDocVw_TLB, SHLOBJ,CommCtrl,textdata,
          Graphics, Controls,
  StdActns, ActnList, ToolWin,
  ExtCtrls, OleCtrls, StdCtrls, ImgList,  ComCtrls;

{type

  TSavo = class(TComObjectFactory)
	  private
		procedure AddKeys;
		procedure RemoveKeys;
	  public
		procedure UpdateRegistry(Register: Boolean); override;
	  end;
}
procedure save(forUrl:String;notes:TList);
function URLtoFile(forURL:wideString):wideString;
function load(forUrl:wideString;caller:pointer):integer;
function loadNotes(caller:pointer;from:TStringList):integer;

implementation

function StrReplace(input,lookfor,replacewith:string):string;
var
i:integer;
begin
i:=pos(lookfor,input);
while(i<>0)do
  begin
  delete(input,i,length(lookfor));
  insert(replacewith,input,i);
  i:=pos(lookfor,input);
  end;
result:=input;
end;

function URLtoFile(forURL:wideString):wideString;
begin
{if(pos('file:///',forURL)=1)then
  delete(forURL,1,8);
if(pos('http://',forURL)=1)or(pos('file://',forURL)=1)then
  delete(forURL,1,7);}
forURL:=StrReplace(forURL,'\','_');
forURL:=StrReplace(forURL,'/','_');
forURL:=StrReplace(forURL,':','');
forURL:=StrReplace(forURL,'*','_');
forURL:=StrReplace(forURL,'?','!');
forURL:=StrReplace(forURL,'"',' ');
forURL:=StrReplace(forURL,'<',' ');
forURL:=StrReplace(forURL,'>',' ');
forURL:=StrReplace(forURL,'|',' ');
result:=forURL+'.html';
end;

//gets bookmark and converts for file
function encode(input:wideString):String;
var
i:integer;
begin
result:='';
for i:=1 to length(input) do
  begin
  result:=result+inttostr(integer(input[i]))+',';
  end;
end;

//gets string from file and converts to IE bookmark
function decode(input:String):wideString;
var
temp:string;
begin
result:='';
while length(input)>0 do
  begin
  temp:=copy(input,1,pos(',',input)-1);
  result:=result+char(strtoint(temp));
  delete(input,1,pos(',',input));
  end;
end;

procedure save(forUrl:String;notes:TList);
var
i:integer;
f:textfile;
temp:PChar;
rn,tn:string;
begin
notes.pack;
if(notes.count=0)then
  begin
  getMem(temp,2048);
  strPCopy(temp,loadMemPath+'\'+URLtoFile(forURL));
  deleteFile(temp);
  freeMem(temp);
  end
else
begin
try
AssignFile(f,loadMemPath+'\'+URLtoFile(forURL));
if IOResult <> 0 then
  begin
  MessageDlg('internal error 201: saving supplet',mtError,[mbOk], 0);
  exit;
  end;
rewrite(f);
except
  MessageDlg('internal error 202: saving supplet',mtError,[mbOk], 0);
  exit;
end;
rn:=char(13)+char(10);
writeln(f,'<html><head>'+rn+
          '<meta name="supplementary info" content="Supplet v1.0">'+rn+
          '<meta name="base document" content="'+forURL+'">'+rn+'<!--'+rn+
          '<SUPPLET>'+rn+'<ANNOTES>');
for i:=0 to notes.count-1 do
  begin
//  writeln(f,);
  tn:=aNote(notes.items[i]).styleClass+rn+encode(aNote(notes.items[i]).bookmark)+rn+aNote(notes.items[i]).location;
  writeln(f,tn);
  tn:='note_timestamp:'+rn+floattostr(aNote(notes.items[i]).timestamp);
  writeln(f,tn);
  tn:='note_ownerstamp:'+rn+aNote(notes.items[i]).ownerstamp;
  writeln(f,tn);
  tn:='marked_text:'+rn+aNote(notes.items[i]).markedText;
  writeln(f,tn);
  if(getStClass(aNote(notes.items[i]).styleClass)='NOTE')then
    begin
    tn:='note_text:'+rn+aNote(notes.items[i]).text;
    writeln(f,tn);
    end;
  writeln(f,'note_end');
  end;
writeln(f,'</ANNOTES>'+rn+'</SUPPLET>'+rn+'-->'+rn+'</head>'+rn+
          '<body>This Supplet contains Metadata like comments and textmarks made on the document <a href="'+forURL+'">'+forURL+'</a>.<br>'+rn+
          'You can either quickly install the Supplet Browser plugin to see the <i>annotated</i> document by going to<br>'+rn+
          '<a href="http://www.supplets.com/download/">http://www.supplets.com/download</a> or click on the above link for the plain document.'+rn+
          '</body>'+rn+'</html>');
CloseFile(f);
end;
end;

procedure readline(var from:TStringList;var return:String);
begin
if(from.count>0)then
  begin
  return:=from.Strings[0];
  from.delete(0);
  end
else
  return:='';
end;

function eos(f:tStringList):boolean;
begin
result:=f.count<=0;
end;

//reads through file until stopword1 or 2 is encountered, all text until then is returned
function readstopword(var f:tStringList;stopword1,stopword2:string):string;
var
temp:string;
found:boolean;
begin
found:=1=2;
result:='';
repeat
readline(f,temp);
if(stopword1<>'')and(pos(stopword1,trim(temp))=1)then
  found:=1=1;
if(stopword2<>'')and(pos(stopword2,trim(temp))=1)then
  found:=1=1;
if(not(found))then
  result:=result+trim(temp)+char(13)+char(10);
until(found)or(eos(f));
end;

//reads through file until stopword1 or 2 is found, corresponding line is returned
function gostopword(var f:tstringlist;stopword1,stopword2:string):string;
var
temp:string;
found:boolean;
begin
found:=1=2;
temp:='';
repeat
readline(f,temp);
if(stopword1<>'')and(pos(stopword1,trim(temp))=1)then
  found:=1=1;
if(stopword2<>'')and(pos(stopword2,trim(temp))=1)then
  found:=1=1;
until(found)or(eos(f));
if(not(eos(f)))then
 result:=temp
else
 result:='';
end;

function load(forUrl:wideString;caller:pointer):integer;
var
tn:String;
f:textfile;
from:TStringList;
begin
from:=TStringList.create;
tn:=loadMemPath+'\'+URLtoFile(forURL);
//MessageDlg('connecting '+forURL,mtInformation,[mbOk], 0);
if(fileexists(tn))then
 begin
  try
  AssignFile(f,tn);
  reset(f);
  if IOResult <> 0 then
    begin
    MessageDlg('internal error 221: loading supplet',mtError,[mbOk], 0);
    exit;
    end;
  while(not(Eof(f)))do
    begin
    readln(f,tn);
    from.add(tn);
    end;
  finally
  CloseFile(f);
  end;
 end;
result:=loadNotes(caller,from);
end;

function loadNotes(caller:pointer;from:TStringList):integer;
var
nNote:aNote;
tn,tn2,tn3,tn4,tn5,tn6:String;
i:integer;
begin
i:=0;
try
  if(not(eos(from)))then
    gostopword(from,'<ANNOTES>','');
  while(not(eos(from)))do
    begin
    tn2:=gostopword(from,'NOTE','MARK');
    inc(i);
    if(tn2<>'')then
      begin
      readline(from,tn3);
      readline(from,tn4);
      tn3:=decode(tn3);
      if(not((mydoc(caller)).alreadyExists(tn3)))then
        begin
        nNote:=myDoc(caller).newNote(tn4,tn2,tn3);
        tn2:=gostopword(from,'note_timestamp:','');
        tn2:=readstopword(from,'note_ownerstamp:','');
        nNote.timestamp:=strtofloat(trim(tn2));
        tn2:=readstopword(from,'marked_text:','');
        nNote.ownerstamp:=trim(tn2);
        nNote.markedText:=trim(readstopword(from,'note_end','note_text:'));
        if(getStClass(nNote.styleClass)='NOTE')then
          nNote.text:=trim(readstopword(from,'note_end',''));
        end
      else
        gostopword(from,'note_end','');
      end;
    end;
except
 MessageDlg('internal error 210: Supplet file corrupted',mtError,[mbOk], 0);
end;
from.free;
result:=i;
end;



end.
